
import com.imsl.stat.ANCOVA;
import com.imsl.math.PrintMatrix;

public class ANCOVAEx1 {

    public static void main(String args[]) {

        double y[][] = {
            {181.0, 228.0, 182.0, 249.0, 259.0, 201.0, 121.0, 339.0, 224.0,
                112.0, 189.0},
            {137.0, 173.0, 177.0, 241.0, 225.0, 223.0, 190.0, 257.0, 337.0,
                189.0, 214.0, 140.0, 196.0, 262.0, 261.0, 356.0, 159.0, 191.0,
                197.0}};
        double x[][][] = new double[1][2][];
        x[0][0] = new double[]{46.0, 52.0, 39.0, 65.0, 54.0, 33.0, 49.0, 76.0,
                    71.0, 41.0, 58.0};
        x[0][1] = new double[]{18.0, 44.0, 33.0, 78.0, 51.0, 43.0, 44.0, 58.0,
                    63.0, 19.0, 42.0, 30.0, 47.0, 58.0, 70.0, 67.0, 31.0, 21.0,
                    56.0};
        ANCOVA awc = new ANCOVA(y, x);

        double testpl[] = awc.compute();
        double aov[] = awc.getANCOVA();

        System.out.println("             * * * Analysis of Variance * * *\n");
        System.out.println("                  Sum of         " +
                "Mean                Prob of");
        System.out.println("Source   DF      Squares        Square    " +
                "Overall F  Larger F");
        System.out.printf("Model  %3.0f     %10.2f      %9.2f  %2.2f      " +
                "%8.6f\n", aov[0], aov[3], aov[6], aov[8], aov[9]);
        System.out.printf("Error   %3.0f    %10.2f     %9.2f \n", aov[1],
                aov[4], aov[7]);
        System.out.printf("Total   %3.0f     %10.2f \n\n\n", aov[2], aov[5]);
        System.out.println("           * * * Test for Parallelism  * * *\n");
        System.out.println("                       Sum of     Mean     F     " +
                " Prob of");
        System.out.println("Source           DF    Squares   Square   Test   " +
                " Larger F");
        System.out.println("Extra due to");
        System.out.printf("Nonparallelism %3.0f %10.2f   %7.2f   %7.5f %5.4f\n",
                testpl[0], testpl[3], testpl[6], testpl[8], testpl[9]);
        System.out.println("Extra Assuming");
        System.out.printf("Nonparallelism  %3.0f  %10.2f  %7.2f \n", testpl[1],
                testpl[4], testpl[7]);
        System.out.println("Error Assuming");
        System.out.printf("Parallelism     %3.0f  %10.2f \n\n\n", testpl[2],
                testpl[5]);
        new PrintMatrix("XY Mean Matrix\n").print(awc.getMeans());
        new PrintMatrix("\n\nVar./Covar. Matrix of Adjusted Group Means" +
                "\n").print(awc.getVarCovAdjustedMeans());
    }
}
